function [ct,U,U_u,U_p,V,S_u,S_p,S_up,S_pp]=GF_sw_sph(r0,phi0,r1,phi1,Rs,cdt)
% Green function in Schwarzschild spherical coordinates
% source (0,r0,phi0) -> field (ct,r1,phi1)
% cdt: time step
% ct: time interval between source and field
% U,V:  4  4
% Ucd:  4  4  4
% S_u =S_a
% S_p =S_b'
% S_up=S_ab'
% S_pp=S_a'b'
[lamda,u]=geodesic_sw_bvp(1,cdt,Rs,r0,r1,phi0,phi1,0);
ct=u(1,end);
r=u(2,:);
u=[u(4:5,:);zeros(1,length(lamda));u(6,:)];
S_u=metric_sw(Rs,r1,pi/2)*u(:,end);
S_p=-metric_sw(Rs,r0,pi/2)*u(:,1);
sv=@(fun,y0) ode45(fun,[0,1],y0,odeset('MaxStep',max(diff(lamda))));
[U,U_u,U_p,V,S_up,S_pp]=Int_null(Rs,lamda,r,u,sv);
end