clear;clc;
addpath .\fdtd_sw
addpath .\GF_sw
%
load('conf_dipole');
fdtd_sw(mdl,exc,out,sw,2000,100);
%
disp('...');
disp('Green function ...');
c=299792458;
BW=1e9;
sgm=0.568/BW;
A=1;
%
Rs=1;
L=0.005;
cdt=L/sqrt(3);
cT=c*16*sgm;
%
Xp=[1.5;0;0];
Xn=[1.5;0;L];
%
X =[1.1;0;0];
[E1,ct1]=dipole_sw(Rs,Xp,Xn,X,A,BW,cdt,cT);
X =[1.9;0;0];
[E2,ct2]=dipole_sw(Rs,Xp,Xn,X,A,BW,cdt,cT);
X =[1.5;0.4;0];
[E3,ct3]=dipole_sw(Rs,Xp,Xn,X,A,BW,cdt,cT);
X =[1.5;0;0.4];
[E4,ct4]=dipole_sw(Rs,Xp,Xn,X,A,BW,cdt,cT);
save('dipole','E1','ct1','E2','ct2','E3','ct3','E4','ct4');
%%%%%%%%%%%%%%%%%%%%%
figure;hold on;
v=load('v1.txt');
plot(v(:,1)*c,v(:,2)/L);
plot(ct1+(0:size(E1,2)-1)*cdt,E1(3,:),'r:');
title('P1');
legend('FDTD','GFM');
%
figure;hold on;
v=load('v2.txt');
plot(v(:,1)*c,v(:,2)/L);
plot(ct2+(0:size(E2,2)-1)*cdt,E2(3,:),'r:');
title('P2');
legend('FDTD','GFM');
%
figure;hold on;
v=load('v3.txt');
plot(v(:,1)*c,v(:,2)/L);
plot(ct3+(0:size(E3,2)-1)*cdt,E3(3,:),'r:');
title('P3');
legend('FDTD','GFM');
%
figure;hold on;
v=load('v4.txt');
plot(v(:,1)*c,v(:,2)/L);
plot(ct4+(0:size(E4,2)-1)*cdt,E4(3,:),'r:');
title('P4');
legend('FDTD','GFM');