function mdl=grid_init(mdl)
n=mdl.Lx_OBi+mdl.Lx_OBo+mdl.Lx_pml;
L1=mdl.x(1)-(mdl.x(2)-mdl.x(1))*(1:n(1)).';
L2=mdl.x(end)+(mdl.x(end)-mdl.x(end-1))*(1:n(2)).';
mdl.x=[flipud(L1);mdl.x(:);L2];
%
n=mdl.Ly_OBi+mdl.Ly_OBo+mdl.Ly_pml;
L1=mdl.y(1)-(mdl.y(2)-mdl.y(1))*(1:n(1)).';
L2=mdl.y(end)+(mdl.y(end)-mdl.y(end-1))*(1:n(2)).';
mdl.y=[flipud(L1);mdl.y(:);L2];
%
n=mdl.Lz_OBi+mdl.Lz_OBo+mdl.Lz_pml;
L1=mdl.z(1)-(mdl.z(2)-mdl.z(1))*(1:n(1)).';
L2=mdl.z(end)+(mdl.z(end)-mdl.z(end-1))*(1:n(2)).';
mdl.z=[flipud(L1);mdl.z(:);L2];
% total number of mesh node
mdl.NX=length(mdl.x);
mdl.NY=length(mdl.y);
mdl.NZ=length(mdl.z);
mdl.SZ=[mdl.NX;mdl.NY;mdl.NZ];
% PML boudary
mdl.Ip=[1+mdl.Lx_pml(1);mdl.NX-mdl.Lx_pml(2)];
mdl.Jp=[1+mdl.Ly_pml(1);mdl.NY-mdl.Ly_pml(2)];
mdl.Kp=[1+mdl.Lz_pml(1);mdl.NZ-mdl.Lz_pml(2)];
%
mdl.fo_X=mdl.Lx_OBo>0;
mdl.fo_Y=mdl.Ly_OBo>0;
mdl.fo_Z=mdl.Lz_OBo>0;
% output boudary
mdl.Io=[mdl.Ip(1)+mdl.Lx_OBo(1);mdl.Ip(2)-mdl.Lx_OBo(2)];
mdl.Jo=[mdl.Jp(1)+mdl.Ly_OBo(1);mdl.Jp(2)-mdl.Ly_OBo(2)];
mdl.Ko=[mdl.Kp(1)+mdl.Lz_OBo(1);mdl.Kp(2)-mdl.Lz_OBo(2)];
%
nx=mdl.Io(2)-mdl.Io(1);
ny=mdl.Jo(2)-mdl.Jo(1);
nz=mdl.Ko(2)-mdl.Ko(1);
mdl.Nox=ny*nz;
mdl.Noy=nx*nz;
mdl.Noz=nx*ny;
%
mdl.fc_X=mdl.Lx_OBi>0;
mdl.fc_Y=mdl.Ly_OBi>0;
mdl.fc_Z=mdl.Lz_OBi>0;
% connection boudary
mdl.Ic=[mdl.Io(1)+mdl.Lx_OBi(1);mdl.Io(2)-mdl.Lx_OBi(2)];
mdl.Jc=[mdl.Jo(1)+mdl.Ly_OBi(1);mdl.Jo(2)-mdl.Ly_OBi(2)];
mdl.Kc=[mdl.Ko(1)+mdl.Lz_OBi(1);mdl.Ko(2)-mdl.Lz_OBi(2)];
%
mdl.Ncx=mdl.Ic(2)-mdl.Ic(1)+1;
mdl.Ncy=mdl.Jc(2)-mdl.Jc(1)+1;
mdl.Ncz=mdl.Kc(2)-mdl.Kc(1)+1;
end