function [mdl,exc,out,v]=init(mdl,exc,out,sw)
if(mdl.Nmedium==0)
    mdl.Nmedium=1;
    mdl.epsr=1;
    mdl.mur=1;
else
    mdl.Nmedium=mdl.Nmedium+1;
    mdl.epsr=[1;mdl.epsr(:)];
    mdl.mur=[1;mdl.mur(:)];
end
dx=diff(mdl.x);
dy=diff(mdl.y);
dz=diff(mdl.z);
mdl.dx0=1/sqrt(1/min(dx)^2+1/min(dy)^2+1/min(dz)^2);  % =c*dt
mdl.dt=mdl.dx0/299792458;
mdl.Ce=mdl.dx0./mdl.epsr;
mdl.Ch=mdl.dx0./mdl.mur;
%
mdl=bound_init(mdl,exc,out);
mdl=grid_init(mdl);
mdl=ind_init(mdl);
v  =pml_init_sw(mdl,sw);
exc=exc_init(mdl,exc,sw);
out=out_init(mdl,out);
%
nx=mdl.NX;ny=mdl.NY;nz=mdl.NZ;
mdl.iiy=nx;
mdl.iiz=nx*ny;
%
v.Ex =zeros(nx,ny,nz);
v.Ey =zeros(nx,ny,nz);
v.Ez =zeros(nx,ny,nz);
v.ZHx=zeros(nx,ny,nz);
v.ZHy=zeros(nx,ny,nz);
v.ZHz=zeros(nx,ny,nz);
end