function v=pml_init_sw(mdl,sw)
PML_param;
v.p_t1=2;
v.p_t2=1;
%
Lex=length(mdl.p_iEx);
Ley=length(mdl.p_iEy);
Lez=length(mdl.p_iEz);
Lhx=length(mdl.p_iHx);
Lhy=length(mdl.p_iHy);
Lhz=length(mdl.p_iHz);
%
v.p_Dx=zeros(Lex,2);
v.p_Dy=zeros(Ley,2);
v.p_Dz=zeros(Lez,2);
v.p_Bx=zeros(Lhx,2);
v.p_By=zeros(Lhy,2);
v.p_Bz=zeros(Lhz,2);
%
v.p_Cdx=zeros(Lex,2);
v.p_Cdy=zeros(Ley,2);
v.p_Cdz=zeros(Lez,2);
v.p_Cex=zeros(Lex,3);
v.p_Cey=zeros(Ley,3);
v.p_Cez=zeros(Lez,3);
%
v.p_Cbx=zeros(Lhx,2);
v.p_Cby=zeros(Lhy,2);
v.p_Cbz=zeros(Lhz,2);
v.p_Chx=zeros(Lhx,3);
v.p_Chy=zeros(Lhy,3);
v.p_Chz=zeros(Lhz,3);
%
r_x0=2/mdl.dx0;
Z0=29.9792458*4*pi; % 迹=c*mu0
Z=Z0*(pml_power+1)/(150*pi);
Zsgm_x_m=Z./[mdl.x(2)-mdl.x(1);mdl.x(end)-mdl.x(end-1)];
Zsgm_y_m=Z./[mdl.y(2)-mdl.y(1);mdl.y(end)-mdl.y(end-1)];
Zsgm_z_m=Z./[mdl.z(2)-mdl.z(1);mdl.z(end)-mdl.z(end-1)];
%
Lx=mdl.Lx_pml;
Ly=mdl.Ly_pml;
Lz=mdl.Lz_pml;
Ip=mdl.Ip;
Jp=mdl.Jp;
Kp=mdl.Kp;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  ex
Zsgm_x=zeros(Lex,1);
Zsgm_y=zeros(Lex,1);
Zsgm_z=zeros(Lex,1);
[i,j,k]=ind2sub(mdl.SZ,mdl.p_iEx);
fx=[i<Ip(1),i>=Ip(2)];
fy=[j<Jp(1),j> Jp(2)];
fz=[k<Kp(1),k> Kp(2)];
for s=1:2
    Zsgm_x(fx(:,s))=Zsgm_x_m(s)*abs((i(fx(:,s))+0.5-Ip(s))/Lx(s)).^pml_power;
    Zsgm_y(fy(:,s))=Zsgm_y_m(s)*abs((j(fy(:,s))    -Jp(s))/Ly(s)).^pml_power;
    Zsgm_z(fz(:,s))=Zsgm_z_m(s)*abs((k(fz(:,s))    -Kp(s))/Lz(s)).^pml_power;
end
epsr=med_bound(mdl,sw,i,0,j,1,k,1);
sr_epsr=sqrt(epsr);
Zsgm_x=Zsgm_x./sr_epsr;
Zsgm_y=Zsgm_y./sr_epsr;
Zsgm_z=Zsgm_z./sr_epsr;
%
A=r_x0+Zsgm_y;
v.p_Cdx(:,1)=(r_x0-Zsgm_y)./A;
A=A.*epsr;
v.p_Cdx(:,2)=2./A;
A=r_x0+Zsgm_z;
v.p_Cex(:,1)= (r_x0-Zsgm_z)./A;
v.p_Cex(:,2)= (r_x0+Zsgm_x)./A;
v.p_Cex(:,3)= (r_x0-Zsgm_x)./A;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  ey
Zsgm_x=zeros(Ley,1);
Zsgm_y=zeros(Ley,1);
Zsgm_z=zeros(Ley,1);
[i,j,k]=ind2sub(mdl.SZ,mdl.p_iEy);
fx=[i<Ip(1),i> Ip(2)];
fy=[j<Jp(1),j>=Jp(2)];
fz=[k<Kp(1),k> Kp(2)];
for s=1:2
    Zsgm_x(fx(:,s))=Zsgm_x_m(s)*abs((i(fx(:,s))    -Ip(s))/Lx(s)).^pml_power;
    Zsgm_y(fy(:,s))=Zsgm_y_m(s)*abs((j(fy(:,s))+0.5-Jp(s))/Ly(s)).^pml_power;
    Zsgm_z(fz(:,s))=Zsgm_z_m(s)*abs((k(fz(:,s))    -Kp(s))/Lz(s)).^pml_power;
end
epsr=med_bound(mdl,sw,i,1,j,0,k,1);
sr_epsr=sqrt(epsr);
Zsgm_x=Zsgm_x./sr_epsr;
Zsgm_y=Zsgm_y./sr_epsr;
Zsgm_z=Zsgm_z./sr_epsr;
%
A=r_x0+Zsgm_z;
v.p_Cdy(:,1)=(r_x0-Zsgm_z)./A;
A=A.*epsr;
v.p_Cdy(:,2)=2./A;
A=r_x0+Zsgm_x;
v.p_Cey(:,1)= (r_x0-Zsgm_x)./A;
v.p_Cey(:,2)= (r_x0+Zsgm_y)./A;
v.p_Cey(:,3)= (r_x0-Zsgm_y)./A;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  ez
Zsgm_x=zeros(Lez,1);
Zsgm_y=zeros(Lez,1);
Zsgm_z=zeros(Lez,1);
[i,j,k]=ind2sub(mdl.SZ,mdl.p_iEz);
fx=[i<Ip(1),i> Ip(2)];
fy=[j<Jp(1),j> Jp(2)];
fz=[k<Kp(1),k>=Kp(2)];
for s=1:2
    Zsgm_x(fx(:,s))=Zsgm_x_m(s)*abs((i(fx(:,s))    -Ip(s))/Lx(s)).^pml_power;
    Zsgm_y(fy(:,s))=Zsgm_y_m(s)*abs((j(fy(:,s))    -Jp(s))/Ly(s)).^pml_power;
    Zsgm_z(fz(:,s))=Zsgm_z_m(s)*abs((k(fz(:,s))+0.5-Kp(s))/Lz(s)).^pml_power;
end
epsr=med_bound(mdl,sw,i,1,j,1,k,0);
sr_epsr=sqrt(epsr);
Zsgm_x=Zsgm_x./sr_epsr;
Zsgm_y=Zsgm_y./sr_epsr;
Zsgm_z=Zsgm_z./sr_epsr;
%
A=r_x0+Zsgm_x;
v.p_Cdz(:,1)=(r_x0-Zsgm_x)./A;
A=A.*epsr;
v.p_Cdz(:,2)=2./A;
A=r_x0+Zsgm_y;
v.p_Cez(:,1)= (r_x0-Zsgm_y)./A;
v.p_Cez(:,2)= (r_x0+Zsgm_z)./A;
v.p_Cez(:,3)= (r_x0-Zsgm_z)./A;
%
clear epsr sr_epsr;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  hx
Zsgm_x=zeros(Lhx,1);
Zsgm_y=zeros(Lhx,1);
Zsgm_z=zeros(Lhx,1);
[i,j,k]=ind2sub(mdl.SZ,mdl.p_iHx);
fx=[i<Ip(1),i> Ip(2)];
fy=[j<Jp(1),j>=Jp(2)];
fz=[k<Kp(1),k>=Kp(2)];
for s=1:2
    Zsgm_x(fx(:,s))=Zsgm_x_m(s)*abs((i(fx(:,s))    -Ip(s))/Lx(s)).^pml_power;
    Zsgm_y(fy(:,s))=Zsgm_y_m(s)*abs((j(fy(:,s))+0.5-Jp(s))/Ly(s)).^pml_power;
    Zsgm_z(fz(:,s))=Zsgm_z_m(s)*abs((k(fz(:,s))+0.5-Kp(s))/Lz(s)).^pml_power;
end
mur=med_bound(mdl,sw,i,1,j,0,k,0);
sr_mur=sqrt(mur);
Zsgm_x=Zsgm_x./sr_mur;
Zsgm_y=Zsgm_y./sr_mur;
Zsgm_z=Zsgm_z./sr_mur;
%
A=r_x0+Zsgm_y;
v.p_Cbx(:,1)=(r_x0-Zsgm_y)./A;
A=A.*mur;
v.p_Cbx(:,2)=2./A;
A=r_x0+Zsgm_z;
v.p_Chx(:,1)= (r_x0-Zsgm_z)./A;
v.p_Chx(:,2)= (r_x0+Zsgm_x)./A;
v.p_Chx(:,3)= (r_x0-Zsgm_x)./A;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  hy
Zsgm_x=zeros(Lhy,1);
Zsgm_y=zeros(Lhy,1);
Zsgm_z=zeros(Lhy,1);
[i,j,k]=ind2sub(mdl.SZ,mdl.p_iHy);
fx=[i<Ip(1),i>=Ip(2)];
fy=[j<Jp(1),j> Jp(2)];
fz=[k<Kp(1),k>=Kp(2)];
for s=1:2
    Zsgm_x(fx(:,s))=Zsgm_x_m(s)*abs((i(fx(:,s))+0.5-Ip(s))/Lx(s)).^pml_power;
    Zsgm_y(fy(:,s))=Zsgm_y_m(s)*abs((j(fy(:,s))    -Jp(s))/Ly(s)).^pml_power;
    Zsgm_z(fz(:,s))=Zsgm_z_m(s)*abs((k(fz(:,s))+0.5-Kp(s))/Lz(s)).^pml_power;
end
mur=med_bound(mdl,sw,i,0,j,1,k,0);
sr_mur=sqrt(mur);
Zsgm_x=Zsgm_x./sr_mur;
Zsgm_y=Zsgm_y./sr_mur;
Zsgm_z=Zsgm_z./sr_mur;
%
A=r_x0+Zsgm_z;
v.p_Cby(:,1)=(r_x0-Zsgm_z)./A;
A=A.*mur;
v.p_Cby(:,2)=2./A;
A=r_x0+Zsgm_x;
v.p_Chy(:,1)= (r_x0-Zsgm_x)./A;
v.p_Chy(:,2)= (r_x0+Zsgm_y)./A;
v.p_Chy(:,3)= (r_x0-Zsgm_y)./A;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  hz
Zsgm_x=zeros(Lhz,1);
Zsgm_y=zeros(Lhz,1);
Zsgm_z=zeros(Lhz,1);
[i,j,k]=ind2sub(mdl.SZ,mdl.p_iHz);
fx=[i<Ip(1),i>=Ip(2)];
fy=[j<Jp(1),j>=Jp(2)];
fz=[k<Kp(1),k> Kp(2)];
for s=1:2
    Zsgm_x(fx(:,s))=Zsgm_x_m(s)*abs((i(fx(:,s))+0.5-Ip(s))/Lx(s)).^pml_power;
    Zsgm_y(fy(:,s))=Zsgm_y_m(s)*abs((j(fy(:,s))+0.5-Jp(s))/Ly(s)).^pml_power;
    Zsgm_z(fz(:,s))=Zsgm_z_m(s)*abs((k(fz(:,s))    -Kp(s))/Lz(s)).^pml_power;
end
mur=med_bound(mdl,sw,i,0,j,0,k,1);
sr_mur=sqrt(mur);
Zsgm_x=Zsgm_x./sr_mur;
Zsgm_y=Zsgm_y./sr_mur;
Zsgm_z=Zsgm_z./sr_mur;
%
A=r_x0+Zsgm_x;
v.p_Cbz(:,1)=(r_x0-Zsgm_x)./A;
A=A.*mur;
v.p_Cbz(:,2)=2./A;
A=r_x0+Zsgm_y;
v.p_Chz(:,1)= (r_x0-Zsgm_y)./A;
v.p_Chz(:,2)= (r_x0+Zsgm_z)./A;
v.p_Chz(:,3)= (r_x0-Zsgm_z)./A;
end